// IEScript.h : Declaration of the CIEScript

#ifndef __IESCRIPT_H_
#define __IESCRIPT_H_

#include "resource.h"       // main symbols


/////////////////////////////////////////////////////////////////////////////
// CIEScript

#define DB_CLASS_NAME (TEXT("ScriptToolBandClass"))

#define SIZE_X   300
#define SIZE_Y   24

class ATL_NO_VTABLE CIEScript : 
   public CComObjectRootEx<CComSingleThreadModel>,
   public CComCoClass<CIEScript, &CLSID_IEScript>,
   public IDeskBand,
   public IInputObject,
   public IObjectWithSite,
   public IPersistStream,
   public IActiveScriptSiteImpl<CIEScript>,
   public IActiveScriptSiteWindowImpl<CIEScript>
{
public:
   HRESULT FinalConstruct();
   void FinalRelease();

DECLARE_REGISTRY_RESOURCEID(IDR_IESCRIPT)
DECLARE_NOT_AGGREGATABLE(CIEScript)
DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CIEScript)
   COM_INTERFACE_ENTRY(IDeskBand)
   COM_INTERFACE_ENTRY(IOleWindow)
   COM_INTERFACE_ENTRY(IDockingWindow)
   COM_INTERFACE_ENTRY(IInputObject)
   COM_INTERFACE_ENTRY(IObjectWithSite)
   COM_INTERFACE_ENTRY(IPersistStream)
   COM_INTERFACE_ENTRY(IPersist)
   COM_INTERFACE_ENTRY(IActiveScriptSite)
   COM_INTERFACE_ENTRY(IActiveScriptSiteWindow)
END_COM_MAP()

public:
   // IOleWindow methods
   STDMETHOD(GetWindow)(HWND*);
   STDMETHOD(ContextSensitiveHelp)(BOOL);

   // IDockingWindow methods
   STDMETHOD(ShowDW)(BOOL fShow);
   STDMETHOD(CloseDW)(DWORD dwReserved);
   STDMETHOD(ResizeBorderDW)(LPCRECT prcBorder, IUnknown* punkToolbarSite, BOOL fReserved);

   // IDeskBand methods
   STDMETHOD(GetBandInfo)(DWORD, DWORD, DESKBANDINFO*);

   // IInputObject methods
   STDMETHOD(UIActivateIO)(BOOL, LPMSG);
   STDMETHOD(HasFocusIO)(void);
   STDMETHOD(TranslateAcceleratorIO)(LPMSG);

   // IObjectWithSite methods
   STDMETHOD(SetSite)(IUnknown*);
   STDMETHOD(GetSite)(REFIID, LPVOID*);

   // IPersistStream methods
   STDMETHOD(GetClassID)(LPCLSID);
   STDMETHOD(IsDirty)(void);
   STDMETHOD(Load)(LPSTREAM);
   STDMETHOD(Save)(LPSTREAM, BOOL);
   STDMETHOD(GetSizeMax)(ULARGE_INTEGER*);

   // IActiveScriptSite
   STDMETHOD(GetItemInfo)(LPCOLESTR pstrName,
                          DWORD dwReturnMask,
                          IUnknown **ppiunkItem,
                          ITypeInfo **ppti);
   STDMETHOD(GetDocVersionString)(BSTR *pbstrVersion);

private:
   static LRESULT CALLBACK WndProc(HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam);
   void FocusChange(BOOL);
   LRESULT OnKillFocus(void);
   LRESULT OnSetFocus(void);
   LRESULT OnPaint(void);
   LRESULT OnCommand(WPARAM wParam, LPARAM lParam);
   LRESULT OnSize(LPARAM);
   LRESULT OnDropDown(LPNMTOOLBAR lpnmtb);
   //
   BOOL OnEditScript(int ID);
   BOOL OnRunScript(int ID);
   //
   BOOL RegisterAndCreateWindow(void);
   //
   BOOL AddButton(int ID);
   void GetScriptFilename(int ID, LPTSTR szPath);

// Variables
public:
   HWND  m_hWnd;
private:
   BOOL  m_bFocus;
   HWND  m_hwndParent;
   DWORD m_dwViewMode;
   DWORD m_dwBandID;
   DWORD m_dwPopupID;
   TCHAR m_szAppPath[MAX_PATH];
   CComQIPtr<IInputObjectSite, &IID_IInputObjectSite> m_spSite;
   CComPtr<IWebBrowser2> m_spWebBrowser2;
   //
   CToolBarCtrl m_ctlToolbar;
   CImageList m_ctlImages;
};

#endif //__IESCRIPT_H_
